package com.qgs.dc.mq.configuration;


import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Desc: "设备：PID13S 相关信息定义"
 * @Author: caixiang
 * @DATE: 2021/6/7 9:11
 */
@Configuration
public class ConfigOfPID13S {

    //水平扩展其他设备的时候 只要：control+R 然后 PID13S=>00C  然后replace all
    public static final String EQUIPMENT_NAME_PID13S = "PID13S";

    public static final String EXCHANGE_NAME_PID13S = EQUIPMENT_NAME_PID13S +"_Exchange";
    public static final String EAP_REQUEST_QUEUE_PID13S = EQUIPMENT_NAME_PID13S +"_EAP_Request_Queue";
    public static final String EAP_RESPONSE_QUEUE_PID13S = EQUIPMENT_NAME_PID13S +"_EAP_Response_Queue";
    public static final String MES_REQUEST_QUEUE_PID13S = EQUIPMENT_NAME_PID13S +"_MES_Request_Queue";
    public static final String MES_RESPONSE_QUEUE_PID13S = EQUIPMENT_NAME_PID13S +"_MES_Response_Queue";
    public static final String EAP_REQUEST_QUEUE_ROUTINGKEY_PID13S = EQUIPMENT_NAME_PID13S +"_EAP_Request_Queue_RoutingKey";
    public static final String EAP_RESPONSE_QUEUE_ROUTINGKEY_PID13S = EQUIPMENT_NAME_PID13S +"_EAP_Response_Queue_RoutingKey";
    public static final String MES_REQUEST_QUEUE_ROUTINGKEY_PID13S = EQUIPMENT_NAME_PID13S +"_MES_Request_Queue_RoutingKey";
    public static final String MES_RESPONSE_QUEUE_ROUTINGKEY_PID13S = EQUIPMENT_NAME_PID13S +"_MES_Response_Queue_RoutingKey";


    @Bean
    public DirectExchange EXCHANGE_NAME_PID13S(){
        return new DirectExchange(EXCHANGE_NAME_PID13S);
    }

    //todo
    @Bean
    public Queue MES_REQUEST_QUEUE_PID13S(){
        Queue queue = new Queue(MES_REQUEST_QUEUE_PID13S);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }
    @Bean
    public Queue MES_RESPONSE_QUEUE_PID13S(){
        Queue queue = new Queue(MES_RESPONSE_QUEUE_PID13S);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }


    @Bean
    public Queue EAP_REQUEST_QUEUE_PID13S(){
        Queue queue = new Queue(EAP_REQUEST_QUEUE_PID13S);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;

    }
    @Bean
    public Queue EAP_RESPONSE_QUEUE_PID13S(){
        Queue queue = new Queue(EAP_RESPONSE_QUEUE_PID13S);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }
    

    @Bean
    public Binding bindExchangeAndQueueA_PID13S(){
        return BindingBuilder.bind(EAP_REQUEST_QUEUE_PID13S()).to(EXCHANGE_NAME_PID13S())
                .with(EAP_REQUEST_QUEUE_ROUTINGKEY_PID13S);
    }
    @Bean
    public Binding bindExchangeAndQueueB_PID13S(){
        return BindingBuilder.bind(EAP_RESPONSE_QUEUE_PID13S()).to(EXCHANGE_NAME_PID13S())
                .with(EAP_RESPONSE_QUEUE_ROUTINGKEY_PID13S);
    }

    @Bean
    public Binding bindExchangeAndQueueC_PID13S(){
        return BindingBuilder.bind(MES_REQUEST_QUEUE_PID13S()).to(EXCHANGE_NAME_PID13S())
                .with(MES_REQUEST_QUEUE_ROUTINGKEY_PID13S);
    }

    @Bean
    public Binding bindExchangeAndQueueD_PID13S(){
        return BindingBuilder.bind(MES_RESPONSE_QUEUE_PID13S()).to(EXCHANGE_NAME_PID13S())
                .with(MES_RESPONSE_QUEUE_ROUTINGKEY_PID13S);
    }
}